﻿// CodeGear C++Builder
// Copyright (c) 1995, 2021 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ClassFile.pas' rev: 35.00 (Linux)

#ifndef ClassfileHPP
#define ClassfileHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <ClassFileConstants.hpp>

//-- user supplied -----------------------------------------------------------

namespace Classfile
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TClassFileItem;
class DELPHICLASS TSignature;
class DELPHICLASS TBaseSignature;
class DELPHICLASS TObjectSignature;
class DELPHICLASS TArraySignature;
class DELPHICLASS TMethodSignature;
class DELPHICLASS TConstantPoolItem;
class DELPHICLASS TConstantClass;
class DELPHICLASS TConstantInteger;
class DELPHICLASS TConstantFloat;
class DELPHICLASS TConstantLong;
class DELPHICLASS TConstantDouble;
class DELPHICLASS TConstantFieldRef;
class DELPHICLASS TConstantMethodRef;
class DELPHICLASS TConstantInterfaceMethodRef;
class DELPHICLASS TConstantString;
class DELPHICLASS TConstantUtf8;
class DELPHICLASS TConstantNameAndType;
class DELPHICLASS TConstantMethodHandle;
class DELPHICLASS TConstantMethodType;
class DELPHICLASS TConstantInvokeDynamic;
class DELPHICLASS TAttribute;
class DELPHICLASS TConstantValueAttribute;
class DELPHICLASS TSourceFileAttribute;
struct TException;
class DELPHICLASS TCodeAttribute;
class DELPHICLASS TDeprecatedAttribute;
class DELPHICLASS TSignatureAttribute;
struct TInnerClass;
class DELPHICLASS TInnerClassesAttribute;
struct TLineNumber;
class DELPHICLASS TLineNumberTableAttribute;
struct TLocalVariable;
class DELPHICLASS TLocalVariableTableAttribute;
struct TMethodParameter;
class DELPHICLASS TMethodParametersAttribute;
class DELPHICLASS TField;
class DELPHICLASS TMethod;
class DELPHICLASS TClassFile;
//-- type declarations -------------------------------------------------------
typedef System::UnicodeString TString;

typedef System::Word UInt16;

typedef unsigned long UInt32;

typedef System::TArray__1<System::Byte> TByteDynArray;

typedef System::TArray__1<System::Word> TWordDynArray;

typedef System::TArray__1<int> TIntegerDynArray;

enum DECLSPEC_DENUM TBaseType : unsigned char { btUnknown, btByte, btChar, btDouble, btFloat, btInt, btLong, btShort, btBoolean };

class PASCALIMPLEMENTATION TClassFileItem : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TClassFile* FClassFile;
	
protected:
	__fastcall TClassFileItem(TClassFile* ClassFile);
	
public:
	__property TClassFile* ClassFile = {read=FClassFile};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TClassFileItem() { }
	
};


class PASCALIMPLEMENTATION TSignature : public TClassFileItem
{
	typedef TClassFileItem inherited;
	
protected:
	__classmethod TSignature* __fastcall CreateSignature(TClassFile* ClassFile, const System::UnicodeString Signature, int &Index)/* overload */;
	__classmethod TSignature* __fastcall CreateSignature(TClassFile* ClassFile, const System::UnicodeString Signature)/* overload */;
	__fastcall TSignature(TClassFile* ClassFile);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TSignature() { }
	
};


typedef System::DynamicArray<TSignature*> TSignatureDynArray;

class PASCALIMPLEMENTATION TBaseSignature : public TSignature
{
	typedef TSignature inherited;
	
private:
	TBaseType FBaseType;
	
protected:
	__fastcall TBaseSignature(TClassFile* ClassFile, TBaseType BaseType);
	
public:
	__property TBaseType BaseType = {read=FBaseType, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TBaseSignature() { }
	
};


class PASCALIMPLEMENTATION TObjectSignature : public TSignature
{
	typedef TSignature inherited;
	
private:
	System::UnicodeString FName;
	
protected:
	__fastcall TObjectSignature(TClassFile* ClassFile, const System::UnicodeString Name);
	
public:
	__property System::UnicodeString Name = {read=FName};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TObjectSignature() { }
	
};


class PASCALIMPLEMENTATION TArraySignature : public TSignature
{
	typedef TSignature inherited;
	
private:
	int FDimension;
	TSignature* FItemSignature;
	
protected:
	__fastcall TArraySignature(TClassFile* ClassFile, int Dimension, TSignature* ItemSignature);
	
public:
	__fastcall virtual ~TArraySignature();
	__property int Dimension = {read=FDimension, nodefault};
	__property TSignature* ItemSignature = {read=FItemSignature};
};


class PASCALIMPLEMENTATION TMethodSignature : public TSignature
{
	typedef TSignature inherited;
	
private:
	TSignatureDynArray FParameters;
	TSignature* FResultType;
	int __fastcall GetParameterCount();
	TSignature* __fastcall GetParameter(int Index);
	
protected:
	__fastcall TMethodSignature(TClassFile* ClassFile, TSignatureDynArray Parameters, TSignature* ResultType);
	
public:
	__fastcall virtual ~TMethodSignature();
	__property int ParameterCount = {read=GetParameterCount, nodefault};
	__property TSignature* Parameter[int Index] = {read=GetParameter};
	__property TSignature* ResultType = {read=FResultType};
};


class PASCALIMPLEMENTATION TConstantPoolItem : public TClassFileItem
{
	typedef TClassFileItem inherited;
	
protected:
	__fastcall TConstantPoolItem(TClassFile* ClassFile);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantPoolItem() { }
	
};


class PASCALIMPLEMENTATION TConstantClass : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FNameIndex;
	System::UnicodeString __fastcall GetName();
	
protected:
	__fastcall TConstantClass(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word NameIndex = {read=FNameIndex, nodefault};
	__property System::UnicodeString Name = {read=GetName};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantClass() { }
	
};


class PASCALIMPLEMENTATION TConstantInteger : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	unsigned long FValue;
	
protected:
	__fastcall TConstantInteger(TClassFile* ClassFile, int &Offset);
	
public:
	__property unsigned long Value = {read=FValue};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantInteger() { }
	
};


class PASCALIMPLEMENTATION TConstantFloat : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	float FValue;
	
protected:
	__fastcall TConstantFloat(TClassFile* ClassFile, int &Offset);
	
public:
	__property float Value = {read=FValue};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantFloat() { }
	
};


class PASCALIMPLEMENTATION TConstantLong : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	unsigned __int64 FValue;
	
protected:
	__fastcall TConstantLong(TClassFile* ClassFile, int &Offset);
	
public:
	__property unsigned __int64 Value = {read=FValue};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantLong() { }
	
};


class PASCALIMPLEMENTATION TConstantDouble : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	double FValue;
	
protected:
	__fastcall TConstantDouble(TClassFile* ClassFile, int &Offset);
	
public:
	__property double Value = {read=FValue};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantDouble() { }
	
};


class PASCALIMPLEMENTATION TConstantFieldRef : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FClassIndex;
	System::Word FNameAndTypeIndex;
	System::UnicodeString __fastcall GetClassValue();
	System::UnicodeString __fastcall GetName();
	System::UnicodeString __fastcall GetTypeName();
	TSignature* __fastcall GetTypeSignature();
	
protected:
	__fastcall TConstantFieldRef(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word ClassIndex = {read=FClassIndex, nodefault};
	__property System::Word NameAndTypeIndex = {read=FNameAndTypeIndex, nodefault};
	__property System::UnicodeString ClassValue = {read=GetClassValue};
	__property System::UnicodeString Name = {read=GetName};
	__property System::UnicodeString TypeName = {read=GetTypeName};
	__property TSignature* TypeSignature = {read=GetTypeSignature};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantFieldRef() { }
	
};


class PASCALIMPLEMENTATION TConstantMethodRef : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FClassIndex;
	System::Word FNameAndTypeIndex;
	System::UnicodeString __fastcall GetClassValue();
	System::UnicodeString __fastcall GetName();
	System::UnicodeString __fastcall GetTypeName();
	TSignature* __fastcall GetTypeSignature();
	
protected:
	__fastcall TConstantMethodRef(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word ClassIndex = {read=FClassIndex, nodefault};
	__property System::Word NameAndTypeIndex = {read=FNameAndTypeIndex, nodefault};
	__property System::UnicodeString ClassValue = {read=GetClassValue};
	__property System::UnicodeString Name = {read=GetName};
	__property System::UnicodeString TypeName = {read=GetTypeName};
	__property TSignature* TypeSignature = {read=GetTypeSignature};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantMethodRef() { }
	
};


class PASCALIMPLEMENTATION TConstantInterfaceMethodRef : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FClassIndex;
	System::Word FNameAndTypeIndex;
	
protected:
	__fastcall TConstantInterfaceMethodRef(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word ClassIndex = {read=FClassIndex, nodefault};
	__property System::Word NameAndTypeIndex = {read=FNameAndTypeIndex, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantInterfaceMethodRef() { }
	
};


class PASCALIMPLEMENTATION TConstantString : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FStringIndex;
	System::UnicodeString __fastcall GetStringValue();
	
protected:
	__fastcall TConstantString(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word StringIndex = {read=FStringIndex, nodefault};
	__property System::UnicodeString StringValue = {read=GetStringValue};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantString() { }
	
};


class PASCALIMPLEMENTATION TConstantUtf8 : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::UnicodeString FValue;
	TSignature* FSignature;
	TSignature* __fastcall GetSignature();
	TMethodSignature* __fastcall GetMethodSignature();
	void __fastcall CheckByte(System::Byte Value);
	
protected:
	__fastcall TConstantUtf8(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::UnicodeString Value = {read=FValue};
	__property TSignature* Signature = {read=GetSignature};
	__property TMethodSignature* MethodSignature = {read=GetMethodSignature};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantUtf8() { }
	
};


class PASCALIMPLEMENTATION TConstantNameAndType : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FNameIndex;
	System::Word FDescriptorIndex;
	System::UnicodeString __fastcall GetDescriptor();
	System::UnicodeString __fastcall GetName();
	TSignature* __fastcall GetSignature();
	
protected:
	__fastcall TConstantNameAndType(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word NameIndex = {read=FNameIndex, nodefault};
	__property System::Word DescriptorIndex = {read=FDescriptorIndex, nodefault};
	__property System::UnicodeString Name = {read=GetName};
	__property System::UnicodeString Descriptor = {read=GetDescriptor};
	__property TSignature* Signature = {read=GetSignature};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantNameAndType() { }
	
};


class PASCALIMPLEMENTATION TConstantMethodHandle : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Byte FReferenceKind;
	System::Word FReferenceIndex;
	
protected:
	__fastcall TConstantMethodHandle(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Byte ReferenceKind = {read=FReferenceKind, nodefault};
	__property System::Word ReferenceIndex = {read=FReferenceIndex, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantMethodHandle() { }
	
};


class PASCALIMPLEMENTATION TConstantMethodType : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FDescriptorIndex;
	System::UnicodeString __fastcall GetDescriptor();
	
protected:
	__fastcall TConstantMethodType(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word DescriptorIndex = {read=FDescriptorIndex, nodefault};
	__property System::UnicodeString Descriptor = {read=GetDescriptor};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantMethodType() { }
	
};


class PASCALIMPLEMENTATION TConstantInvokeDynamic : public TConstantPoolItem
{
	typedef TConstantPoolItem inherited;
	
private:
	System::Word FBootstrapMethodAttrIndex;
	System::Word FNameAndTypeIndex;
	
protected:
	__fastcall TConstantInvokeDynamic(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word BootstrapMethodAttrIndex = {read=FBootstrapMethodAttrIndex, nodefault};
	__property System::Word NameAndTypeIndex = {read=FNameAndTypeIndex, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantInvokeDynamic() { }
	
};


typedef System::DynamicArray<TConstantPoolItem*> TConstantPoolItemDynArray;

class PASCALIMPLEMENTATION TAttribute : public TClassFileItem
{
	typedef TClassFileItem inherited;
	
private:
	unsigned long FLength;
	System::Word FNameIndex;
	int FStart;
	System::UnicodeString __fastcall GetName();
	
protected:
	__classmethod TAttribute* __fastcall CreateAttribute(TClassFile* ClassFile, int &Offset);
	__fastcall TAttribute(TClassFile* ClassFile, int Start);
	
public:
	__property System::Word NameIndex = {read=FNameIndex, nodefault};
	__property System::UnicodeString Name = {read=GetName};
	__property int Start = {read=FStart, nodefault};
	__property unsigned long Length = {read=FLength};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TAttribute() { }
	
};


typedef System::DynamicArray<TAttribute*> TAttributeDynArray;

class PASCALIMPLEMENTATION TConstantValueAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
private:
	System::Word FValueIndex;
	TConstantPoolItem* __fastcall GetValue();
	
protected:
	__fastcall TConstantValueAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word ValueIndex = {read=FValueIndex, nodefault};
	__property TConstantPoolItem* Value = {read=GetValue};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TConstantValueAttribute() { }
	
};


class PASCALIMPLEMENTATION TSourceFileAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
private:
	System::Word FSourceFileIndex;
	System::UnicodeString __fastcall GetSourceFile();
	
protected:
	__fastcall TSourceFileAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word SourceFileIndex = {read=FSourceFileIndex, nodefault};
	__property System::UnicodeString SourceFile = {read=GetSourceFile};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TSourceFileAttribute() { }
	
};


#pragma pack(push,16)
struct DECLSPEC_DRECORD TException
{
public:
	System::Word StartPc;
	System::Word EndPc;
	System::Word HandlerPc;
	System::Word CatchType;
};
#pragma pack(pop)


typedef System::DynamicArray<TException> TExceptionDynArray;

class PASCALIMPLEMENTATION TCodeAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
public:
	System::Byte operator[](int Index) { return this->Code[Index]; }
	
private:
	System::Word FMaxStack;
	System::Word FMaxLocals;
	unsigned long FCodeLength;
	TExceptionDynArray FExceptions;
	TAttributeDynArray FAttributes;
	System::Byte __fastcall GetCode(int Index);
	TAttribute* __fastcall GetAttribute(int Index);
	int __fastcall GetAttributeCount();
	TException __fastcall GetException(int Index);
	int __fastcall GetExceptionCount();
	
protected:
	__fastcall TCodeAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word MaxStack = {read=FMaxStack, nodefault};
	__property System::Word MaxLocals = {read=FMaxLocals, nodefault};
	__property unsigned long CodeLength = {read=FCodeLength};
	__property System::Byte Code[int Index] = {read=GetCode/*, default*/};
	__property int ExceptionCount = {read=GetExceptionCount, nodefault};
	__property TException Exception[int Index] = {read=GetException};
	__property int AttributeCount = {read=GetAttributeCount, nodefault};
	__property TAttribute* Attribute[int Index] = {read=GetAttribute};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TCodeAttribute() { }
	
};


class PASCALIMPLEMENTATION TDeprecatedAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
protected:
	__fastcall TDeprecatedAttribute(TClassFile* ClassFile, int &Offset);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TDeprecatedAttribute() { }
	
};


class PASCALIMPLEMENTATION TSignatureAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
private:
	System::Word FDescriptorIndex;
	TConstantUtf8* __fastcall GetDescriptor();
	
protected:
	__fastcall TSignatureAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property System::Word DescriptorIndex = {read=FDescriptorIndex, nodefault};
	__property TConstantUtf8* Descriptor = {read=GetDescriptor};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TSignatureAttribute() { }
	
};


#pragma pack(push,16)
struct DECLSPEC_DRECORD TInnerClass
{
public:
	System::Word InnerClassIndex;
	System::Word OuterClassIndex;
	System::Word InnerNameIndex;
	System::Word InnerClassAccessFlags;
};
#pragma pack(pop)


typedef System::DynamicArray<TInnerClass> TInnerClassDynArray;

class PASCALIMPLEMENTATION TInnerClassesAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
private:
	TInnerClassDynArray FClasses;
	TInnerClass __fastcall GetInnerClass(int Index);
	int __fastcall GetInnerClassCount();
	System::UnicodeString __fastcall GetInnerName(int Index);
	
protected:
	__fastcall TInnerClassesAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property TInnerClassDynArray Classes = {read=FClasses};
	__property int InnerClassCount = {read=GetInnerClassCount, nodefault};
	__property TInnerClass InnerClass[int Index] = {read=GetInnerClass};
	__property System::UnicodeString InnerName[int Index] = {read=GetInnerName};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TInnerClassesAttribute() { }
	
};


#pragma pack(push,16)
struct DECLSPEC_DRECORD TLineNumber
{
public:
	System::Word StartPc;
	System::Word LineNumber;
};
#pragma pack(pop)


typedef System::DynamicArray<TLineNumber> TLineNumberDynArray;

class PASCALIMPLEMENTATION TLineNumberTableAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
public:
	TLineNumber operator[](int Index) { return this->LineNumber[Index]; }
	
private:
	TLineNumberDynArray FLineNumbers;
	TLineNumber __fastcall GetLineNumber(int Index);
	int __fastcall GetLineNumberCount();
	
protected:
	__fastcall TLineNumberTableAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property int LineNumberCount = {read=GetLineNumberCount, nodefault};
	__property TLineNumber LineNumber[int Index] = {read=GetLineNumber/*, default*/};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TLineNumberTableAttribute() { }
	
};


#pragma pack(push,16)
struct DECLSPEC_DRECORD TLocalVariable
{
public:
	System::Word StartPc;
	System::Word Length;
	System::Word NameIndex;
	System::Word DescriptorIndex;
	System::Word Index;
};
#pragma pack(pop)


typedef System::DynamicArray<TLocalVariable> TLocalVariableDynArray;

class PASCALIMPLEMENTATION TLocalVariableTableAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
public:
	TLocalVariable operator[](int Index) { return this->LocalVariable[Index]; }
	
private:
	TLocalVariableDynArray FLocalVariables;
	int __fastcall GetLocalVariableCount();
	TLocalVariable __fastcall GetLocalVariable(int Index);
	System::UnicodeString __fastcall GetLocalVariableName(int Index);
	System::UnicodeString __fastcall GetLocalVariableType(int Index);
	void __fastcall CheckIndex(int Index);
	
protected:
	__fastcall TLocalVariableTableAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property int LocalVariableCount = {read=GetLocalVariableCount, nodefault};
	__property TLocalVariable LocalVariable[int Index] = {read=GetLocalVariable/*, default*/};
	__property System::UnicodeString LocalVariableName[int Index] = {read=GetLocalVariableName};
	__property System::UnicodeString LocalVariableType[int Index] = {read=GetLocalVariableType};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TLocalVariableTableAttribute() { }
	
};


#pragma pack(push,16)
struct DECLSPEC_DRECORD TMethodParameter
{
public:
	System::Word NameIndex;
	System::Word AccessFlags;
};
#pragma pack(pop)


typedef System::DynamicArray<TMethodParameter> TMethodParameterDynArray;

class PASCALIMPLEMENTATION TMethodParametersAttribute : public TAttribute
{
	typedef TAttribute inherited;
	
public:
	TMethodParameter operator[](int Index) { return this->MethodParameter[Index]; }
	
private:
	TMethodParameterDynArray FMethodParameters;
	void __fastcall CheckIndex(int Index);
	int __fastcall GetMethodParameterCount();
	TMethodParameter __fastcall GetMethodParameter(int Index);
	System::UnicodeString __fastcall GetMethodParameterName(int Index);
	bool __fastcall GetIsMethodParameterFinal(int Index);
	bool __fastcall GetIsMethodParameterSynthetic(int Index);
	bool __fastcall GetIsMethodParameterMandated(int Index);
	
protected:
	__fastcall TMethodParametersAttribute(TClassFile* ClassFile, int &Offset);
	
public:
	__property int MethodParameterCount = {read=GetMethodParameterCount, nodefault};
	__property TMethodParameter MethodParameter[int Index] = {read=GetMethodParameter/*, default*/};
	__property System::UnicodeString MethodParameterName[int Index] = {read=GetMethodParameterName};
	__property bool IsMethodParameterFinal[int Index] = {read=GetIsMethodParameterFinal};
	__property bool IsMethodParameterSynthetic[int Index] = {read=GetIsMethodParameterSynthetic};
	__property bool IsMethodParameterMandated[int Index] = {read=GetIsMethodParameterMandated};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TMethodParametersAttribute() { }
	
};


class PASCALIMPLEMENTATION TField : public TClassFileItem
{
	typedef TClassFileItem inherited;
	
private:
	System::Word FFlags;
	System::Word FNameIndex;
	System::Word FDescriptorIndex;
	TAttributeDynArray FAttributes;
	bool __fastcall GetIsPublic();
	bool __fastcall GetIsPrivate();
	bool __fastcall GetIsProtected();
	bool __fastcall GetIsEnum();
	bool __fastcall GetIsFinal();
	bool __fastcall GetIsStatic();
	bool __fastcall GetIsSynthetic();
	bool __fastcall GetIsTransient();
	bool __fastcall GetIsVolatile();
	TAttribute* __fastcall GetAttribute(int Index);
	int __fastcall GetAttributeCount();
	TConstantUtf8* __fastcall GetDescriptor();
	TConstantUtf8* __fastcall GetName();
	bool __fastcall GetIsConstant();
	bool __fastcall GetIsIntegerConstant();
	bool __fastcall GetIsLongConstant();
	bool __fastcall GetIsFloatConstant();
	bool __fastcall GetIsDoubleConstant();
	bool __fastcall GetIsStringConstant();
	TConstantValueAttribute* __fastcall GetConstant();
	unsigned long __fastcall GetIntegerConstant();
	unsigned __int64 __fastcall GetLongConstant();
	float __fastcall GetFloatConstant();
	double __fastcall GetDoubleConstant();
	System::UnicodeString __fastcall GetStringConstant();
	
protected:
	__fastcall TField(TClassFile* ClassFile, int &Offset);
	
public:
	__fastcall virtual ~TField();
	__property System::Word Flags = {read=FFlags, nodefault};
	__property System::Word NameIndex = {read=FNameIndex, nodefault};
	__property TConstantUtf8* Name = {read=GetName};
	__property System::Word DescriptorIndex = {read=FDescriptorIndex, nodefault};
	__property TConstantUtf8* Descriptor = {read=GetDescriptor};
	__property int AttributeCount = {read=GetAttributeCount, nodefault};
	__property TAttribute* Attribute[int Index] = {read=GetAttribute};
	__property bool IsPublic = {read=GetIsPublic, nodefault};
	__property bool IsPrivate = {read=GetIsPrivate, nodefault};
	__property bool IsProtected = {read=GetIsProtected, nodefault};
	__property bool IsStatic = {read=GetIsStatic, nodefault};
	__property bool IsFinal = {read=GetIsFinal, nodefault};
	__property bool IsVolatile = {read=GetIsVolatile, nodefault};
	__property bool IsTransient = {read=GetIsTransient, nodefault};
	__property bool IsSynthetic = {read=GetIsSynthetic, nodefault};
	__property bool IsEnum = {read=GetIsEnum, nodefault};
	__property bool IsConstant = {read=GetIsConstant, nodefault};
	__property bool IsIntegerConstant = {read=GetIsIntegerConstant, nodefault};
	__property bool IsLongConstant = {read=GetIsLongConstant, nodefault};
	__property bool IsFloatConstant = {read=GetIsFloatConstant, nodefault};
	__property bool IsDoubleConstant = {read=GetIsDoubleConstant, nodefault};
	__property bool IsStringConstant = {read=GetIsStringConstant, nodefault};
	__property TConstantValueAttribute* Constant = {read=GetConstant};
	__property unsigned long IntegerContant = {read=GetIntegerConstant};
	__property unsigned __int64 LongConstant = {read=GetLongConstant};
	__property float FloatConstant = {read=GetFloatConstant};
	__property double DoubleConstant = {read=GetDoubleConstant};
	__property System::UnicodeString StringConstant = {read=GetStringConstant};
};


typedef System::DynamicArray<TField*> TFieldDynArray;

class PASCALIMPLEMENTATION TMethod : public TClassFileItem
{
	typedef TClassFileItem inherited;
	
private:
	System::Word FFlags;
	System::Word FNameIndex;
	System::Word FDescriptorIndex;
	TAttributeDynArray FAttributes;
	TCodeAttribute* FCode;
	TLocalVariableTableAttribute* FLocalVariables;
	TMethodParametersAttribute* FMethodParameters;
	System::TArray__1<int> FParameters;
	bool __fastcall GetIsAbstract();
	bool __fastcall GetIsBridge();
	bool __fastcall GetIsFinal();
	bool __fastcall GetIsNative();
	bool __fastcall GetIsPrivate();
	bool __fastcall GetIsProtected();
	bool __fastcall GetIsPublic();
	bool __fastcall GetIsStatic();
	bool __fastcall GetIsStrict();
	bool __fastcall GetIsSynchronized();
	bool __fastcall GetIsSynthetic();
	bool __fastcall GetIsVarargs();
	TConstantUtf8* __fastcall GetDescriptor();
	TConstantUtf8* __fastcall GetName();
	TAttribute* __fastcall GetAttribute(int Index);
	int __fastcall GetAttributeCount();
	bool __fastcall GetIsProcedure();
	TSignature* __fastcall GetParameter(int Index);
	int __fastcall GetParameterCount();
	TSignature* __fastcall GetResultType();
	System::UnicodeString __fastcall GetParameterName(int Index);
	System::UnicodeString __fastcall GetParameterType(int Index);
	TCodeAttribute* __fastcall GetCode();
	TLocalVariableTableAttribute* __fastcall GetLocalVariables();
	TMethodParametersAttribute* __fastcall GetMethodParameters();
	bool __fastcall GetIsDeprecated();
	bool __fastcall GetIsConstructor();
	System::TArray__1<int> __fastcall GetParameters();
	void __fastcall CheckParameterIndex(int Index);
	__property System::TArray__1<int> Parameters = {read=GetParameters};
	
protected:
	__fastcall TMethod(TClassFile* ClassFile, int &Offset);
	
public:
	__fastcall virtual ~TMethod();
	__property System::Word Flags = {read=FFlags, nodefault};
	__property System::Word NameIndex = {read=FNameIndex, nodefault};
	__property TConstantUtf8* Name = {read=GetName};
	__property System::Word DescriptorIndex = {read=FDescriptorIndex, nodefault};
	__property TConstantUtf8* Descriptor = {read=GetDescriptor};
	__property int AttributeCount = {read=GetAttributeCount, nodefault};
	__property TAttribute* Attribute[int Index] = {read=GetAttribute};
	__property int ParameterCount = {read=GetParameterCount, nodefault};
	__property TSignature* Parameter[int Index] = {read=GetParameter};
	__property System::UnicodeString ParameterName[int Index] = {read=GetParameterName};
	__property System::UnicodeString ParameterType[int Index] = {read=GetParameterType};
	__property TSignature* ResultType = {read=GetResultType};
	__property TCodeAttribute* Code = {read=GetCode};
	__property TLocalVariableTableAttribute* LocalVariables = {read=GetLocalVariables};
	__property TMethodParametersAttribute* MethodParameters = {read=GetMethodParameters};
	__property bool IsPublic = {read=GetIsPublic, nodefault};
	__property bool IsPrivate = {read=GetIsPrivate, nodefault};
	__property bool IsProtected = {read=GetIsProtected, nodefault};
	__property bool IsStatic = {read=GetIsStatic, nodefault};
	__property bool IsFinal = {read=GetIsFinal, nodefault};
	__property bool IsSynchronized = {read=GetIsSynchronized, nodefault};
	__property bool IsBridge = {read=GetIsBridge, nodefault};
	__property bool IsVarargs = {read=GetIsVarargs, nodefault};
	__property bool IsNative = {read=GetIsNative, nodefault};
	__property bool IsAbstract = {read=GetIsAbstract, nodefault};
	__property bool IsStrict = {read=GetIsStrict, nodefault};
	__property bool IsSynthetic = {read=GetIsSynthetic, nodefault};
	__property bool IsProcedure = {read=GetIsProcedure, nodefault};
	__property bool IsDeprecated = {read=GetIsDeprecated, nodefault};
	__property bool IsConstructor = {read=GetIsConstructor, nodefault};
};


typedef System::DynamicArray<TMethod*> TMethodDynArray;

class PASCALIMPLEMENTATION TClassFile : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::UnicodeString FFileName;
	System::TArray__1<System::Byte> FData;
	unsigned long FMagic;
	System::Word FMinorVersion;
	System::Word FMajorVersion;
	TConstantPoolItemDynArray FConstantPool;
	System::Word FFlags;
	System::Word FThisClassIndex;
	System::Word FSuperClassIndex;
	System::TArray__1<System::Word> FInterfaces;
	TFieldDynArray FFields;
	TMethodDynArray FMethods;
	TAttributeDynArray FAttributes;
	System::Byte __fastcall GetByte(int &Offset);
	System::Word __fastcall GetUInt16(int &Offset);
	unsigned long __fastcall GetUInt32(int &Offset);
	unsigned __int64 __fastcall GetUInt64(int &Offset);
	void __fastcall CreateConstantPool(int &Offset);
	bool __fastcall GetIsPublic();
	bool __fastcall GetIsFinal();
	bool __fastcall GetSpecialSuper();
	bool __fastcall GetIsInterface();
	bool __fastcall GetIsAbstract();
	bool __fastcall GetIsSynthetic();
	bool __fastcall GetIsAnotation();
	bool __fastcall GetIsEnum();
	TField* __fastcall GetField(int Index);
	TMethod* __fastcall GetMethod(int Index);
	TAttribute* __fastcall GetAttribute(int Index);
	TConstantUtf8* __fastcall GetConstantPoolUtf8(int Index);
	TConstantPoolItem* __fastcall GetConstantPoolItem(int Index);
	TConstantClass* __fastcall GetConstantPoolClass(int Index);
	TConstantNameAndType* __fastcall GetConstantPoolNameAndType(int Index);
	int __fastcall GetAttributeCount();
	int __fastcall GetFieldCount();
	int __fastcall GetMethodCount();
	HIDESBASE TConstantClass* __fastcall GetInterface(int Index);
	int __fastcall GetInterfaceCount();
	TConstantClass* __fastcall GetSuperClass();
	TConstantClass* __fastcall GetThisClass();
	
public:
	__fastcall TClassFile(const System::UnicodeString FileName, System::TArray__1<System::Byte> Data);
	__fastcall virtual ~TClassFile();
	__property System::UnicodeString FileName = {read=FFileName};
	__property unsigned long Magic = {read=FMagic};
	__property System::Word MinorVersion = {read=FMinorVersion, nodefault};
	__property System::Word MajorVersion = {read=FMajorVersion, nodefault};
	__property TConstantPoolItemDynArray ConstantPool = {read=FConstantPool};
	__property TConstantPoolItem* ConstantPoolItem[int Index] = {read=GetConstantPoolItem};
	__property TConstantUtf8* ConstantPoolUtf8[int Index] = {read=GetConstantPoolUtf8};
	__property TConstantClass* ConstantPoolClass[int Index] = {read=GetConstantPoolClass};
	__property TConstantNameAndType* ConstantPoolNameAndType[int Index] = {read=GetConstantPoolNameAndType};
	__property System::Word Flags = {read=FFlags, nodefault};
	__property System::Word ThisClassIndex = {read=FThisClassIndex, nodefault};
	__property TConstantClass* ThisClass = {read=GetThisClass};
	__property System::Word SuperClassIndex = {read=FSuperClassIndex, nodefault};
	__property TConstantClass* SuperClass = {read=GetSuperClass};
	__property int InterfaceCount = {read=GetInterfaceCount, nodefault};
	__property TConstantClass* Interface_[int Index] = {read=GetInterface};
	__property int FieldCount = {read=GetFieldCount, nodefault};
	__property TField* Field[int Index] = {read=GetField};
	__property int MethodCount = {read=GetMethodCount, nodefault};
	__property TMethod* Method[int Index] = {read=GetMethod};
	__property int AttributeCount = {read=GetAttributeCount, nodefault};
	__property TAttribute* Attribute[int Index] = {read=GetAttribute};
	__property bool IsPublic = {read=GetIsPublic, nodefault};
	__property bool IsFinal = {read=GetIsFinal, nodefault};
	__property bool SpecialSuper = {read=GetSpecialSuper, nodefault};
	__property bool IsInterface = {read=GetIsInterface, nodefault};
	__property bool IsAbstract = {read=GetIsAbstract, nodefault};
	__property bool IsSynthetic = {read=GetIsSynthetic, nodefault};
	__property bool IsAnotation = {read=GetIsAnotation, nodefault};
	__property bool IsEnum = {read=GetIsEnum, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Classfile */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_CLASSFILE)
using namespace Classfile;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ClassfileHPP
