﻿// CodeGear C++Builder
// Copyright (c) 1995, 2021 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'JNI.pas' rev: 35.00 (Linux)

#ifndef JniHPP
#define JniHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>

//-- user supplied -----------------------------------------------------------

namespace Jni
{
//-- forward type declarations -----------------------------------------------
struct JValue;
struct JNINativeMethod;
struct JNINativeInterface_;
struct JavaVMOption;
struct JavaVMInitArgs;
struct JavaVMAttachArgs;
struct JNIInvokeInterface_;
//-- type declarations -------------------------------------------------------
typedef int JInt;

typedef __int64 JLong;

typedef System::Int8 JByte;

typedef bool JBoolean;

typedef System::WideChar JChar;

typedef short JShort;

typedef float JFloat;

typedef double JDouble;

typedef int JSize;

typedef void * JObject;

typedef void * JClass;

typedef void * JThrowable;

typedef void * JString;

typedef void * JArray;

typedef void * JBooleanArray;

typedef void * JByteArray;

typedef void * JCharArray;

typedef void * JShortArray;

typedef void * JIntArray;

typedef void * JLongArray;

typedef void * JFloatArray;

typedef void * JDoubleArray;

typedef void * JObjectArray;

typedef void * JWeak;

#pragma pack(push,1)
struct DECLSPEC_DRECORD JValue
{
	
public:
	union
	{
		struct 
		{
			void *L;
		};
		struct 
		{
			double D;
		};
		struct 
		{
			float F;
		};
		struct 
		{
			__int64 J;
		};
		struct 
		{
			int I;
		};
		struct 
		{
			short S;
		};
		struct 
		{
			System::WideChar C;
		};
		struct 
		{
			System::Int8 B;
		};
		struct 
		{
			bool Z;
		};
		
	};
};
#pragma pack(pop)


typedef void * JFieldID;

typedef void * JMethodID;

typedef int *PJInt;

typedef __int64 *PJLong;

typedef System::Int8 *PJByte;

typedef bool *PJBoolean;

typedef System::WideChar *PJChar;

typedef short *PJShort;

typedef float *PJFloat;

typedef double *PJDouble;

typedef JValue *PJValue;

typedef void * VaList;

enum DECLSPEC_DENUM JObjectRefType : unsigned char { JNIInvalidRefType, JNILocalRefType, JNIGlobalRefType, JNIWeakGlobalRefType };

#pragma pack(push,1)
struct DECLSPEC_DRECORD JNINativeMethod
{
public:
	char *Name;
	char *Signature;
	void *FnPtr;
};
#pragma pack(pop)


typedef JNINativeMethod *PJNINativeMethod;

typedef JNIInvokeInterface_ *JavaVM;

typedef JavaVM *PJavaVM;

typedef JNINativeInterface_ *JNIEnv;

typedef JNIEnv *PJNIEnv;

#pragma pack(push,1)
struct DECLSPEC_DRECORD JNINativeInterface_
{
public:
	void *reserved0;
	void *reserved1;
	void *reserved2;
	void *reserved3;
	int __cdecl (*GetVersion)(PJNIEnv Env);
	void * __cdecl (*DefineClass)(PJNIEnv Env, const char * Name, void * Loader, const PJByte Buf, int Len);
	void * __cdecl (*FindClass)(PJNIEnv Env, const char * Name);
	void * __cdecl (*FromReflectedMethod)(PJNIEnv Env, void * Method);
	void * __cdecl (*FromReflectedField)(PJNIEnv Env, void * Field);
	void * __cdecl (*ToReflectedMethod)(PJNIEnv Env, void * Cls, void * MethodID, bool IsStatic);
	void * __cdecl (*GetSuperclass)(PJNIEnv Env, void * Sub);
	bool __cdecl (*IsAssignableFrom)(PJNIEnv Env, void * Sub, void * Sup);
	void * __cdecl (*ToReflectedField)(PJNIEnv Env, void * Cls, void * FieldID, bool IsStatic);
	int __cdecl (*Throw)(PJNIEnv Env, void * Obj);
	int __cdecl (*ThrowNew)(PJNIEnv Env, void * Clazz, const char * Msg);
	void * __cdecl (*ExceptionOccurred)(PJNIEnv Env);
	void __cdecl (*ExceptionDescribe)(PJNIEnv Env);
	void __cdecl (*ExceptionClear)(PJNIEnv Env);
	void __cdecl (*FatalError)(PJNIEnv Env, const char * Msg);
	int __cdecl (*PushLocalFrame)(PJNIEnv Env, int Capacity);
	void * __cdecl (*PopLocalFrame)(PJNIEnv Env, void * Result);
	void * __cdecl (*NewGlobalRef)(PJNIEnv Env, void * LObj);
	void __cdecl (*DeleteGlobalRef)(PJNIEnv Env, void * GRef);
	void __cdecl (*DeleteLocalRef)(PJNIEnv Env, void * Obj);
	bool __cdecl (*IsSameObject)(PJNIEnv Env, void * Obj1, void * Obj2);
	void * __cdecl (*NewLocalRef)(PJNIEnv Env, void * Ref);
	int __cdecl (*EnsureLocalCapacity)(PJNIEnv Env, int Capacity);
	void * __cdecl (*AllocObject)(PJNIEnv Env, void * Clazz);
	void * __cdecl (*NewObject)(PJNIEnv Env, void * Clazz, void * MethodID);
	void * __cdecl (*NewObjectV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	void * __cdecl (*NewObjectA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	void * __cdecl (*GetObjectClass)(PJNIEnv Env, void * Obj);
	bool __cdecl (*IsInstanceOf)(PJNIEnv Env, void * Obj, void * Clazz);
	void * __cdecl (*GetMethodID)(PJNIEnv Env, void * Clazz, const char * Name, const char * Sig);
	void * __cdecl (*CallObjectMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	void * __cdecl (*CallObjectMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	void * __cdecl (*CallObjectMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	bool __cdecl (*CallBooleanMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	bool __cdecl (*CallBooleanMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	bool __cdecl (*CallBooleanMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	System::Int8 __cdecl (*CallByteMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	System::Int8 __cdecl (*CallByteMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	System::Int8 __cdecl (*CallByteMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	System::WideChar __cdecl (*CallCharMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	System::WideChar __cdecl (*CallCharMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	System::WideChar __cdecl (*CallCharMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	short __cdecl (*CallShortMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	short __cdecl (*CallShortMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	short __cdecl (*CallShortMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	int __cdecl (*CallIntMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	int __cdecl (*CallIntMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	int __cdecl (*CallIntMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	__int64 __cdecl (*CallLongMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	__int64 __cdecl (*CallLongMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	__int64 __cdecl (*CallLongMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	float __cdecl (*CallFloatMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	float __cdecl (*CallFloatMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	float __cdecl (*CallFloatMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	double __cdecl (*CallDoubleMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	double __cdecl (*CallDoubleMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	double __cdecl (*CallDoubleMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	void __cdecl (*CallVoidMethod)(PJNIEnv Env, void * Obj, void * MethodID);
	void __cdecl (*CallVoidMethodV)(PJNIEnv Env, void * Obj, void * MethodID, void * Args);
	void __cdecl (*CallVoidMethodA)(PJNIEnv Env, void * Obj, void * MethodID, const PJValue Args);
	void * __cdecl (*CallNonvirtualObjectMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	void * __cdecl (*CallNonvirtualObjectMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	void * __cdecl (*CallNonvirtualObjectMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	bool __cdecl (*CallNonvirtualBooleanMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	bool __cdecl (*CallNonvirtualBooleanMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	bool __cdecl (*CallNonvirtualBooleanMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	System::Int8 __cdecl (*CallNonvirtualByteMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	System::Int8 __cdecl (*CallNonvirtualByteMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	System::Int8 __cdecl (*CallNonvirtualByteMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	System::WideChar __cdecl (*CallNonvirtualCharMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	System::WideChar __cdecl (*CallNonvirtualCharMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	System::WideChar __cdecl (*CallNonvirtualCharMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	short __cdecl (*CallNonvirtualShortMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	short __cdecl (*CallNonvirtualShortMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	short __cdecl (*CallNonvirtualShortMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	int __cdecl (*CallNonvirtualIntMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	int __cdecl (*CallNonvirtualIntMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	int __cdecl (*CallNonvirtualIntMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	__int64 __cdecl (*CallNonvirtualLongMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	__int64 __cdecl (*CallNonvirtualLongMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	__int64 __cdecl (*CallNonvirtualLongMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	float __cdecl (*CallNonvirtualFloatMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	float __cdecl (*CallNonvirtualFloatMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	float __cdecl (*CallNonvirtualFloatMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	double __cdecl (*CallNonvirtualDoubleMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	double __cdecl (*CallNonvirtualDoubleMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	double __cdecl (*CallNonvirtualDoubleMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	void __cdecl (*CallNonvirtualVoidMethod)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID);
	void __cdecl (*CallNonvirtualVoidMethodV)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, void * Args);
	void __cdecl (*CallNonvirtualVoidMethodA)(PJNIEnv Env, void * Obj, void * Clazz, void * MethodID, const PJValue Args);
	void * __cdecl (*GetFieldID)(PJNIEnv Env, void * Clazz, const char * Name, const char * Sig);
	void * __cdecl (*GetObjectField)(PJNIEnv Env, void * Obj, void * FieldID);
	bool __cdecl (*GetBooleanField)(PJNIEnv Env, void * Obj, void * FieldID);
	System::Int8 __cdecl (*GetByteField)(PJNIEnv Env, void * Obj, void * FieldID);
	System::WideChar __cdecl (*GetCharField)(PJNIEnv Env, void * Obj, void * FieldID);
	short __cdecl (*GetShortField)(PJNIEnv Env, void * Obj, void * FieldID);
	int __cdecl (*GetIntField)(PJNIEnv Env, void * Obj, void * FieldID);
	__int64 __cdecl (*GetLongField)(PJNIEnv Env, void * Obj, void * FieldID);
	float __cdecl (*GetFloatField)(PJNIEnv Env, void * Obj, void * FieldID);
	double __cdecl (*GetDoubleField)(PJNIEnv Env, void * Obj, void * FieldID);
	void __cdecl (*SetObjectField)(PJNIEnv Env, void * Obj, void * FieldID, void * Val);
	void __cdecl (*SetBooleanField)(PJNIEnv Env, void * Obj, void * FieldID, bool Val);
	void __cdecl (*SetByteField)(PJNIEnv Env, void * Obj, void * FieldID, System::Int8 Val);
	void __cdecl (*SetCharField)(PJNIEnv Env, void * Obj, void * FieldID, System::WideChar Val);
	void __cdecl (*SetShortField)(PJNIEnv Env, void * Obj, void * FieldID, short Val);
	void __cdecl (*SetIntField)(PJNIEnv Env, void * Obj, void * FieldID, int Val);
	void __cdecl (*SetLongField)(PJNIEnv Env, void * Obj, void * FieldID, __int64 Val);
	void __cdecl (*SetFloatField)(PJNIEnv Env, void * Obj, void * FieldID, float Val);
	void __cdecl (*SetDoubleField)(PJNIEnv Env, void * Obj, void * FieldID, double Val);
	void * __cdecl (*GetStaticMethodID)(PJNIEnv Env, void * Clazz, const char * Name, const char * Sig);
	void * __cdecl (*CallStaticObjectMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	void * __cdecl (*CallStaticObjectMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	void * __cdecl (*CallStaticObjectMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	bool __cdecl (*CallStaticBooleanMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	bool __cdecl (*CallStaticBooleanMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	bool __cdecl (*CallStaticBooleanMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	System::Int8 __cdecl (*CallStaticByteMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	System::Int8 __cdecl (*CallStaticByteMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	System::Int8 __cdecl (*CallStaticByteMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	System::WideChar __cdecl (*CallStaticCharMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	System::WideChar __cdecl (*CallStaticCharMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	System::WideChar __cdecl (*CallStaticCharMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	short __cdecl (*CallStaticShortMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	short __cdecl (*CallStaticShortMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	short __cdecl (*CallStaticShortMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	int __cdecl (*CallStaticIntMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	int __cdecl (*CallStaticIntMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	int __cdecl (*CallStaticIntMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	__int64 __cdecl (*CallStaticLongMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	__int64 __cdecl (*CallStaticLongMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	__int64 __cdecl (*CallStaticLongMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	float __cdecl (*CallStaticFloatMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	float __cdecl (*CallStaticFloatMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	float __cdecl (*CallStaticFloatMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	double __cdecl (*CallStaticDoubleMethod)(PJNIEnv Env, void * Clazz, void * MethodID);
	double __cdecl (*CallStaticDoubleMethodV)(PJNIEnv Env, void * Clazz, void * MethodID, void * Args);
	double __cdecl (*CallStaticDoubleMethodA)(PJNIEnv Env, void * Clazz, void * MethodID, const PJValue Args);
	void __cdecl (*CallStaticVoidMethod)(PJNIEnv Env, void * Cls, void * MethodID);
	void __cdecl (*CallStaticVoidMethodV)(PJNIEnv Env, void * Cls, void * MethodID, void * Args);
	void __cdecl (*CallStaticVoidMethodA)(PJNIEnv Env, void * Cls, void * MethodID, const PJValue Args);
	void * __cdecl (*GetStaticFieldID)(PJNIEnv Env, void * Clazz, const char * Name, const char * Sig);
	void * __cdecl (*GetStaticObjectField)(PJNIEnv Env, void * Clazz, void * FieldID);
	bool __cdecl (*GetStaticBooleanField)(PJNIEnv Env, void * Clazz, void * FieldID);
	System::Int8 __cdecl (*GetStaticByteField)(PJNIEnv Env, void * Clazz, void * FieldID);
	System::WideChar __cdecl (*GetStaticCharField)(PJNIEnv Env, void * Clazz, void * FieldID);
	short __cdecl (*GetStaticShortField)(PJNIEnv Env, void * Clazz, void * FieldID);
	int __cdecl (*GetStaticIntField)(PJNIEnv Env, void * Clazz, void * FieldID);
	__int64 __cdecl (*GetStaticLongField)(PJNIEnv Env, void * Clazz, void * FieldID);
	float __cdecl (*GetStaticFloatField)(PJNIEnv Env, void * Clazz, void * FieldID);
	double __cdecl (*GetStaticDoubleField)(PJNIEnv Env, void * Clazz, void * FieldID);
	void __cdecl (*SetStaticObjectField)(PJNIEnv Env, void * Clazz, void * FieldID, void * Value);
	void __cdecl (*SetStaticBooleanField)(PJNIEnv Env, void * Clazz, void * FieldID, bool Value);
	void __cdecl (*SetStaticByteField)(PJNIEnv Env, void * Clazz, void * FieldID, System::Int8 Value);
	void __cdecl (*SetStaticCharField)(PJNIEnv Env, void * Clazz, void * FieldID, System::WideChar Value);
	void __cdecl (*SetStaticShortField)(PJNIEnv Env, void * Clazz, void * FieldID, short Value);
	void __cdecl (*SetStaticIntField)(PJNIEnv Env, void * Clazz, void * FieldID, int Value);
	void __cdecl (*SetStaticLongField)(PJNIEnv Env, void * Clazz, void * FieldID, __int64 Value);
	void __cdecl (*SetStaticFloatField)(PJNIEnv Env, void * Clazz, void * FieldID, float Value);
	void __cdecl (*SetStaticDoubleField)(PJNIEnv Env, void * Clazz, void * FieldID, double Value);
	void * __cdecl (*NewString)(PJNIEnv Env, const PJChar Unicode, int Len);
	int __cdecl (*GetStringLength)(PJNIEnv Env, void * Str);
	PJChar __cdecl (*GetStringChars)(PJNIEnv Env, void * Str, bool &IsCopy);
	void __cdecl (*ReleaseStringChars)(PJNIEnv Env, void * Str, const PJChar Chars);
	void * __cdecl (*NewStringUTF)(PJNIEnv Env, const char * Utf);
	int __cdecl (*GetStringUTFLength)(PJNIEnv Env, void * Str);
	char * __cdecl (*GetStringUTFChars)(PJNIEnv Env, void * Str, bool &IsCopy);
	void __cdecl (*ReleaseStringUTFChars)(PJNIEnv Env, void * Str, const char * Chars);
	int __cdecl (*GetArrayLength)(PJNIEnv Env, void * Array_);
	void * __cdecl (*NewObjectArray)(PJNIEnv Env, int Len, void * Clazz, void * Init);
	void * __cdecl (*GetObjectArrayElement)(PJNIEnv Env, void * Array_, int Index);
	void __cdecl (*SetObjectArrayElement)(PJNIEnv Env, void * Array_, int Index, void * Val);
	void * __cdecl (*NewBooleanArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewByteArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewCharArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewShortArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewIntArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewLongArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewFloatArray)(PJNIEnv Env, int Len);
	void * __cdecl (*NewDoubleArray)(PJNIEnv Env, int Len);
	PJBoolean __cdecl (*GetBooleanArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJByte __cdecl (*GetByteArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJChar __cdecl (*GetCharArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJShort __cdecl (*GetShortArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJInt __cdecl (*GetIntArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJLong __cdecl (*GetLongArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJFloat __cdecl (*GetFloatArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	PJDouble __cdecl (*GetDoubleArrayElements)(PJNIEnv Env, void * Array_, bool &IsCopy);
	void __cdecl (*ReleaseBooleanArrayElements)(PJNIEnv Env, void * Array_, PJBoolean Elems, int Mode);
	void __cdecl (*ReleaseByteArrayElements)(PJNIEnv Env, void * Array_, PJByte Elems, int Mode);
	void __cdecl (*ReleaseCharArrayElements)(PJNIEnv Env, void * Array_, PJChar Elems, int Mode);
	void __cdecl (*ReleaseShortArrayElements)(PJNIEnv Env, void * Array_, PJShort Elems, int Mode);
	void __cdecl (*ReleaseIntArrayElements)(PJNIEnv Env, void * Array_, PJInt Elems, int Mode);
	void __cdecl (*ReleaseLongArrayElements)(PJNIEnv Env, void * Array_, PJLong Elems, int Mode);
	void __cdecl (*ReleaseFloatArrayElements)(PJNIEnv Env, void * Array_, PJFloat Elems, int Mode);
	void __cdecl (*ReleaseDoubleArrayElements)(PJNIEnv Env, void * Array_, PJDouble Elems, int Mode);
	void __cdecl (*GetBooleanArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJBoolean Buf);
	void __cdecl (*GetByteArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJByte Buf);
	void __cdecl (*GetCharArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJChar Buf);
	void __cdecl (*GetShortArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJShort Buf);
	void __cdecl (*GetIntArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJInt Buf);
	void __cdecl (*GetLongArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJLong Buf);
	void __cdecl (*GetFloatArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJFloat Buf);
	void __cdecl (*GetDoubleArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, PJDouble Buf);
	void __cdecl (*SetBooleanArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJBoolean Buf);
	void __cdecl (*SetByteArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJByte Buf);
	void __cdecl (*SetCharArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJChar Buf);
	void __cdecl (*SetShortArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJShort Buf);
	void __cdecl (*SetIntArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJInt Buf);
	void __cdecl (*SetLongArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJLong Buf);
	void __cdecl (*SetFloatArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJFloat Buf);
	void __cdecl (*SetDoubleArrayRegion)(PJNIEnv Env, void * Array_, int Start, int Len, const PJDouble Buf);
	int __cdecl (*RegisterNatives)(PJNIEnv Env, void * Clazz, const PJNINativeMethod Methods, int NMethods);
	int __cdecl (*UnregisterNatives)(PJNIEnv Env, void * Clazz);
	int __cdecl (*MonitorEnter)(PJNIEnv Env, void * Obj);
	int __cdecl (*MonitorExit)(PJNIEnv Env, void * Obj);
	int __cdecl (*GetJavaVM)(PJNIEnv Env, /* out */ PJavaVM &VM);
	void __cdecl (*GetStringRegion)(PJNIEnv Env, void * Str, int Start, int Len, PJChar Buf);
	void __cdecl (*GetStringUTFRegion)(PJNIEnv Env, void * Str, int Start, int Len, char * Buf);
	void * __cdecl (*GetPrimitiveArrayCritical)(PJNIEnv Env, void * Array_, bool &IsCopy);
	void __cdecl (*ReleasePrimitiveArrayCritical)(PJNIEnv Env, void * Array_, void * Carray, int Mode);
	PJChar __cdecl (*GetStringCritical)(PJNIEnv Env, void * String_, bool &IsCopy);
	void __cdecl (*ReleaseStringCritical)(PJNIEnv Env, void * String_, const PJChar CString);
	void * __cdecl (*NewWeakGlobalRef)(PJNIEnv Env, void * Obj);
	void __cdecl (*DeleteWeakGlobalRef)(PJNIEnv Env, void * Ref);
	bool __cdecl (*ExceptionCheck)(PJNIEnv Env);
	void * __cdecl (*NewDirectByteBuffer)(PJNIEnv Env, void * Address, __int64 Capacity);
	void * __cdecl (*GetDirectBufferAddress)(PJNIEnv Env, void * Buf);
	__int64 __cdecl (*GetDirectBufferCapacity)(PJNIEnv Env, void * Buf);
	JObjectRefType __cdecl (*GetObjectRefType)(PJNIEnv Env, void * Obj);
	void * __cdecl (*GetModule)(PJNIEnv Env, void * Clazz);
};
#pragma pack(pop)


#pragma pack(push,1)
struct DECLSPEC_DRECORD JavaVMOption
{
public:
	char *OptionString;
	void *ExtraInfo;
};
#pragma pack(pop)


#pragma pack(push,1)
struct DECLSPEC_DRECORD JavaVMInitArgs
{
public:
	int Version;
	int NOptions;
	JavaVMOption *Options;
	bool IgnoreUnrecognized;
};
#pragma pack(pop)


#pragma pack(push,1)
struct DECLSPEC_DRECORD JavaVMAttachArgs
{
public:
	int Version;
	char *Name;
	void *Group;
};
#pragma pack(pop)


#pragma pack(push,1)
struct DECLSPEC_DRECORD JNIInvokeInterface_
{
public:
	void *reserved0;
	void *reserved1;
	void *reserved2;
	int __cdecl (*DestroyJavaVM)(PJavaVM Vm);
	int __cdecl (*AttachCurrentThread)(PJavaVM Vm, /* out */ PJNIEnv &Env, JavaVMAttachArgs &Args);
	int __cdecl (*DetachCurrentThread)(PJavaVM Vm);
	int __cdecl (*GetEnv)(PJavaVM Vm, /* out */ void * &Env, int Version);
	int __cdecl (*AttachCurrentThreadAsDaemon)(PJavaVM Vm, /* out */ PJNIEnv &Env, JavaVMAttachArgs &Args);
};
#pragma pack(pop)


typedef int __cdecl (*JNI_GetDefaultJavaVMInitArgs)(/* out */ JavaVMInitArgs &Args);

typedef int __cdecl (*JNI_CreateJavaVM)(/* out */ PJavaVM &VM, /* out */ PJNIEnv &Env, JavaVMInitArgs &Args);

typedef int __cdecl (*JNI_GetCreatedJavaVMs)(/* out */ PJavaVM &VM, int Size, /* out */ int &OutSize);

typedef int __cdecl (*JNI_OnLoad)(PJavaVM VM, void * Reserved);

typedef void __cdecl (*JNI_OnUnload)(PJavaVM VM, void * Reserved);

//-- var, const, procedure ---------------------------------------------------
static constexpr System::Int8 JNI_FALSE = System::Int8(0x0);
static constexpr System::Int8 JNI_TRUE = System::Int8(0x1);
static constexpr System::Int8 JNI_OK = System::Int8(0x0);
static constexpr System::Int8 JNI_ERR = System::Int8(-1);
static constexpr System::Int8 JNI_EDETACHED = System::Int8(-2);
static constexpr System::Int8 JNI_EVERSION = System::Int8(-3);
static constexpr System::Int8 JNI_ENOMEM = System::Int8(-4);
static constexpr System::Int8 JNI_EEXIST = System::Int8(-5);
static constexpr System::Int8 JNI_EINVAL = System::Int8(-6);
static constexpr System::Int8 JNI_COMMIT = System::Int8(0x1);
static constexpr System::Int8 JNI_ABORT = System::Int8(0x2);
static constexpr int JNI_VERSION_1_1 = int(0x10001);
static constexpr int JNI_VERSION_1_2 = int(0x10002);
static constexpr int JNI_VERSION_1_4 = int(0x10004);
static constexpr int JNI_VERSION_1_6 = int(0x10006);
static constexpr int JNI_VERSION_1_8 = int(0x10008);
static constexpr int JNI_VERSION_9 = int(0x90000);
static constexpr int JNI_VERSION_10 = int(0xa0000);
}	/* namespace Jni */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_JNI)
using namespace Jni;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// JniHPP
